using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CallCenterApi.DB;
using System.Data;
using System.Data.SqlClient;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_SMS_SentSMS
	/// </summary>
    public partial class T_SMS_SentSMS
    {
        public T_SMS_SentSMS()
        { }
        #region  BasicMethod

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int SMSID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_SMS_SentSMS");
            strSql.Append(" where ");
            strSql.Append(" SMSID = @SMSID  ");
            SqlParameter[] parameters = {
                    new SqlParameter("@SMSID", SqlDbType.Int,4)
            };
            parameters[0].Value = SMSID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }



        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_SMS_SentSMS model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_SMS_SentSMS(");
            strSql.Append("Info,F_UserID,F_CustomerID,F_Name,F_CreateDate,TelNum,Content,State,SendTime,TaskID");
            strSql.Append(") values (");
            strSql.Append("@Info,@F_UserID,@F_CustomerID,@F_Name,@F_CreateDate,@TelNum,@Content,@State,@SendTime,@TaskID");
            strSql.Append(") ");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                        new SqlParameter("@Info", SqlDbType.NVarChar,50) ,
                        new SqlParameter("@F_UserID", SqlDbType.Int,4) ,
                        new SqlParameter("@F_CustomerID", SqlDbType.Int,4) ,
                        new SqlParameter("@F_Name", SqlDbType.NVarChar,50) ,
                        new SqlParameter("@F_CreateDate", SqlDbType.DateTime) ,
                        new SqlParameter("@TelNum", SqlDbType.VarChar,20) ,
                        new SqlParameter("@Content", SqlDbType.NVarChar,100) ,
                        new SqlParameter("@State", SqlDbType.Int,4) ,
                        new SqlParameter("@SendTime", SqlDbType.DateTime),
                        new SqlParameter("@TaskID", SqlDbType.Int,4) 

            };

            parameters[0].Value = model.Info;
            parameters[1].Value = model.F_UserID;
            parameters[2].Value = model.F_CustomerID;
            parameters[3].Value = model.F_Name;
            parameters[4].Value = model.F_CreateDate;
            parameters[5].Value = model.TelNum;
            parameters[6].Value = model.Content;
            parameters[7].Value = model.State;
            parameters[8].Value = model.SendTime;
            parameters[9].Value = model.TaskID;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {

                return Convert.ToInt32(obj);

            }

        }


        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_SMS_SentSMS model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_SMS_SentSMS set ");

            strSql.Append(" Info = @Info , ");
            strSql.Append(" F_UserID = @F_UserID , ");
            strSql.Append(" F_CustomerID = @F_CustomerID , ");
            strSql.Append(" F_Name = @F_Name , ");
            strSql.Append(" F_CreateDate = @F_CreateDate , ");
            strSql.Append(" TelNum = @TelNum , ");
            strSql.Append(" Content = @Content , ");
            strSql.Append(" State = @State , ");
            strSql.Append(" SendTime = @SendTime , ");
            strSql.Append(" TaskID = @TaskID ");
            strSql.Append(" where SMSID=@SMSID ");

            SqlParameter[] parameters = {
                        new SqlParameter("@SMSID", SqlDbType.Int,4) ,
                        new SqlParameter("@Info", SqlDbType.NVarChar,50) ,
                        new SqlParameter("@F_UserID", SqlDbType.Int,4) ,
                        new SqlParameter("@F_CustomerID", SqlDbType.Int,4) ,
                        new SqlParameter("@F_Name", SqlDbType.NVarChar,50) ,
                        new SqlParameter("@F_CreateDate", SqlDbType.DateTime) ,
                        new SqlParameter("@TelNum", SqlDbType.VarChar,20) ,
                        new SqlParameter("@Content", SqlDbType.NVarChar,100) ,
                        new SqlParameter("@State", SqlDbType.Int,4) ,
                        new SqlParameter("@SendTime", SqlDbType.DateTime),
                        new SqlParameter("@TaskID", SqlDbType.Int,4)

            };

            parameters[0].Value = model.SMSID;
            parameters[1].Value = model.Info;
            parameters[2].Value = model.F_UserID;
            parameters[3].Value = model.F_CustomerID;
            parameters[4].Value = model.F_Name;
            parameters[5].Value = model.F_CreateDate;
            parameters[6].Value = model.TelNum;
            parameters[7].Value = model.Content;
            parameters[8].Value = model.State;
            parameters[9].Value = model.SendTime;
            parameters[10].Value = model.TaskID;
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int SMSID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_SMS_SentSMS ");
            strSql.Append(" where SMSID=@SMSID");
            SqlParameter[] parameters = {
                    new SqlParameter("@SMSID", SqlDbType.Int,4)
            };
            parameters[0].Value = SMSID;


            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 批量删除一批数据
        /// </summary>
        public bool DeleteList(string SMSIDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_SMS_SentSMS ");
            strSql.Append(" where ID in (" + SMSIDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_SMS_SentSMS GetModel(int SMSID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append("  from T_SMS_SentSMS ");
            strSql.Append(" where SMSID=@SMSID");
            SqlParameter[] parameters = {
                    new SqlParameter("@SMSID", SqlDbType.Int,4)
            };
            parameters[0].Value = SMSID;


            CallCenterApi.Model.T_SMS_SentSMS model = new CallCenterApi.Model.T_SMS_SentSMS();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);

            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["SMSID"].ToString() != "")
                {
                    model.SMSID = int.Parse(ds.Tables[0].Rows[0]["SMSID"].ToString());
                }
                model.Info = ds.Tables[0].Rows[0]["Info"].ToString();
                if (ds.Tables[0].Rows[0]["F_UserID"].ToString() != "")
                {
                    model.F_UserID = int.Parse(ds.Tables[0].Rows[0]["F_UserID"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CustomerID"].ToString() != "")
                {
                    model.F_CustomerID = int.Parse(ds.Tables[0].Rows[0]["F_CustomerID"].ToString());
                }
                model.F_Name = ds.Tables[0].Rows[0]["F_Name"].ToString();
                if (ds.Tables[0].Rows[0]["F_CreateDate"].ToString() != "")
                {
                    model.F_CreateDate = DateTime.Parse(ds.Tables[0].Rows[0]["F_CreateDate"].ToString());
                }
                model.TelNum = ds.Tables[0].Rows[0]["TelNum"].ToString();
                model.Content = ds.Tables[0].Rows[0]["Content"].ToString();
                if (ds.Tables[0].Rows[0]["State"].ToString() != "")
                {
                    model.State = int.Parse(ds.Tables[0].Rows[0]["State"].ToString());
                }
                if (ds.Tables[0].Rows[0]["SendTime"].ToString() != "")
                {
                    model.SendTime = DateTime.Parse(ds.Tables[0].Rows[0]["SendTime"].ToString());
                }
                if (ds.Tables[0].Rows[0]["TaskID"].ToString() != "")
                {
                    model.TaskID = int.Parse(ds.Tables[0].Rows[0]["TaskID"].ToString());
                }

                return model;
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append(" FROM T_SMS_SentSMS ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" * ");
            strSql.Append(" FROM T_SMS_SentSMS ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }


        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_SMS_SentSMS ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.SMSID desc");
            }
            strSql.Append(")AS Row, T.*  from T_SMS_SentSMS T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
